/**************************************************************************
 *									  *
 * 		 Copyright (C) 1986, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ident "$Revision: 1.4 $"

/**************************************************************************
 *
 * 	gse.h
 *
 *  	Device dependent information for the gse device driver (gse.c)
 *	running on Silicon Graphics workstations
 *
 *	REVISIONS:
 *
 *	 6-02-88  HRG	Added copyright
 *	05-19-88	Added p_pid.
 *	04-20-88	Added #defines for q ptrs.
 *
 ***************************************************************************/

/*
 * Configuration info
 */
#define GSE_MAXCTLR	4
#define GSE_MAX_ADDR	512*1024
#define GSE_BUFFERSIZE	4200
#define GSE_RESETIME	10*HZ
/*
 * Device location info
 */
/* queue stuff */
#define QFETCH		0x0f0a		/* outbound q ptrs.	*/
#define QSTORE		0x0f0c
#define	GSGWFP		0X0F22		/* cmd q ptrs.		*/
#define GSGWSP		0X0F24
#define	GWGSFP		0X0F26
#define	GWGSSP		0X0F28

#define GWGSCQ		0x800
#define CMDQLEN		0x10
#define VECTOR_CMD	5
#define RESETCODE	0x20
#define QN_MASK		0xf
/*
 * State variable definitions
 */
#define GSE_INIT	1
#define GSE_OPEN	2
#define GSE_WAIT	4
#define GSE_INTPEND	8
#define GSE_SELECT	0x10
#define GSE_RESET	0x20
#define GSE_SIGNAL	0x40
/*
 * Device structure
 */
struct gse_state
	{
	int state;		/* device state */
	int base;		/* physical VME A32 base address */
	unsigned short *rbase;	/* physical VME A16 reset address */
	int vector;		/* interrupt vector */
	unsigned short *buffer;	/* kernel data buffer */
	struct proc *proc;	/* user structure pointer */
	short p_pid;	/* pid of opener.				*/
	int signal;		/* signal number to use for wakeup */
	};
